//: c08:StringSortTest.java
// From Thinking in Java, 2nd Edition
// Available at http://www.BruceEckel.com
// (c) Bruce Eckel 1999
// Copyright notice in Copyright.txt
// Testing the generic sorting ArrayList
package c08;
import java.util.*;

public class StringSortTest {
  static class StringCompare implements Compare {
    public boolean lessThan(Object l, Object r) {
      return ((String)l).toLowerCase().compareTo(
        ((String)r).toLowerCase()) < 0;
    }
    public boolean 
    lessThanOrEqual(Object l, Object r) {
      return ((String)l).toLowerCase().compareTo(
        ((String)r).toLowerCase()) <= 0;
    }
  }
  public static void main(String[] args) {
    SortList sv = 
      new SortList(new StringCompare());
    sv.add("d");
    sv.add("A");
    sv.add("C");
    sv.add("c");
    sv.add("b");
    sv.add("B");
    sv.add("D");
    sv.add("a");
    sv.sort();
    Iterator e = sv.iterator();
    while(e.hasNext())
      System.out.println(e.next());
  }
} ///:~
